"""
    File:        fibonacci_.py
    Author:      Chris Kelly
    Date:        March 2016
    Description: Demonstrates the recursive computation of 
                 numbers in the Fibonacci sequence, at a given 
                 position n, where n >= 1.  
"""

import time

# A constant used as a parameter 
# to the sleep function of the 
# time module.  You should not make 
# this too large
DELAY = 0.01

# Recursively computes the nth Fibonacci 
# number.  Each call to this function 
# includes a delay, as defined by the 
# DELAY constant.
def fib(n):
    time.sleep(DELAY)
    if n <= 2:
        return 1
    else:
        return fib(n-1) + fib(n-2)

# Calculate the amount of Fibonacci numbers
# specified by the user.  (Don't go over 12)
# Pay attention to how much longer the
# calculations take as the printing moves along

nums = int (input ("How many Fibonacci numbers? "))

for i in range (1, nums+1):
    print ("Fibonacci", i, "=", fib(i))