"""
    File:        fibonacci_dict.py
    Author:      Chris Kelly
    Date:        March 2016
    Description: Demonstrates the recursive computation of 
                 numbers in the Fibonacci sequence, at a given 
                 position n, where n >= 1.  This version uses a 
                 dictionary to store values for numbers that 
                 have already been calculated.
"""

import time

# A constant used as a parameter 
# to the sleep function of the 
# time module.  You should not make 
# this too large
DELAY = 0.01

# A constant used for a dictionary
# that holds previously calculated
# Fibonacci numbers
DICT = {}

def fib(n):
    time.sleep(DELAY)
    if n in DICT:
        return DICT[n]
    else:
        result = None
        if n <= 2:
            result = 1
        else:
            result = fib(n-1) + fib(n-2)
        DICT[n] = result
        return result

# Calculate the amount of Fibonacci numbers
# specified by the user. (Go as high as you want.)
# Pay attention to how much faster this code 
# runs, as compared to the purely recursive 
# version.

nums = int (input ("How many Fibonacci numbers? "))

for i in range (1, nums+1):
    print ("Fibonacci", i, "=", fib(i))