"""
    File:        fibonacci_dict.py
    Author:      Chris Kelly
    Date:        March 2016
    Description: Demonstrates the recursive computation of 
                 numbers in the Fibonacci sequence, at a given 
                 position n, where n >= 1.  This version uses a 
                 dictionary to store values for numbers that 
                 have already been calculated.
"""

import time

# A constant used as a parameter 
# to the sleep function of the 
# time module.  You should not make 
# this too large
DELAY = 0.01

# Calculate the amount of Fibonacci numbers
# specified by the user. (Go as high as you want.)
# Pay attention to how much faster this code 
# runs, as compared to the purely recursive 
# version.

nums = int (input ("How many Fibonacci numbers? "))

for n in range (1, nums+1):
    result = 0
    f_Nminus1 = 1
    f_Nminus2 = 1
    for j in range (n):
        f_Nminus2 = f_Nminus1
        f_Nminus1 = result
        result = f_Nminus1 + f_Nminus2
    print ("Fibonacci", n, "=", result)
    time.sleep(DELAY)